#ifndef _DINT_H
#define _DINT_H

// This file was automatically generated by objch.

//==============================================================================
//
//           DInt - the integer number class in the ofc-library
//
//               Copyright (C) 2003  Dick van Oudheusden
//  
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free
// Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//==============================================================================
// 
//  $Date: 2005/02/05 06:25:38 $ $Revision: 1.11 $
//
//==============================================================================

#include "ofc/config.h"

#include "ofc/DComparable.h"
#include "ofc/DTextable.h"
#include "ofc/DDatable.h"
#include "ofc/DParsable.h"

#include "ofc/DText.h"
#include "ofc/DData.h"

// The Int class implements a number of methods for storing and manipulating int numbers.

@interface DInt : Object <DComparable,DTextable,DDatable,DParsable>
{
@private
  int          _int;
}


//// Constructors

//
// Initialise to number zero
//
// @return the object
//
- (DInt *) init;

//
// Initialise to a number
//
// @param number   the number
//
// @return the object
//
- (DInt *) init :(int) number;


//// Member methods

//
// Get the integer number
//
// @return the number
//
- (int) get;

//
// Set the integer number
//
// @param number  the integer
//
// @return the object
//
- (DInt *) set :(int) number;


//// Comparable protocol

//
// Compare two integer objects
//
// @param other    the object to compare with
//
// @return the result of the comparison (-1,0,1)
//
- (int) compare :(DInt *) other;


//// Parsable protocol

//
// Parse a string for an int number
//
// @param cstr     the string to be parsed (moved to the first no-parsable char)
//
// @return the result (0, ERANGE, ENODATA)
//
- (int) fromString :(char **) cstr;


//// Textable protocol

//
// Return a text string 
//
// @return a (new) text string with the integer number
//
- (DText *) toText;


//// Datable protocol

//
// Return a data string
//
// @return a (new) data string
//
- (DData *) toData;


//// Endian methods

//
// Return the BigEndian (network order) order for the object
//
// @return the big endian converted int
//
- (int) toBigEndian;

#ifndef WORDS_BIGENDIAN
#endif
//
// Return the LittleEndian order for the object
//
// @return the little endian converted int
//
- (int) toLittleEndian;

#ifdef WORDS_BIGENDIAN
#endif
@end
#endif
