#ifndef _DLONG_H
#define _DLONG_H

// This file was automatically generated by objch.

//==============================================================================
//
//            DLong - the long number class in the ofc-library
//
//               Copyright (C) 2003  Dick van Oudheusden
//  
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free
// Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//==============================================================================
// 
//  $Date: 2004/02/20 20:16:35 $ $Revision: 1.10 $
//
//==============================================================================

#include "ofc/config.h"

#include "ofc/DComparable.h"
#include "ofc/DTextable.h"
#include "ofc/DDatable.h"
#include "ofc/DParsable.h"

#include "ofc/DText.h"
#include "ofc/DData.h"

// The long class implements a number of methods for storing and manipulating long numbers.

@interface DLong : Object <DComparable,DTextable,DDatable,DParsable>
{
@private
  long        _nr;
}


//// Constructors

//
// Initialises to zero number
//
// @return the object
//
- (DLong *) init;

//
// Initialise to a number
//
// @param number   the number
//
// @return the object
//
- (DLong *) init :(long) number;


//// Member methods

//
// Get the long number
//
// @return the number
//
- (long) get;

//
// Set the long number
//
// @param number  the long
//
// @return the object
//
- (DLong *) set :(long) number;


//// Comparable protocol

//
// Compare two long objects
//
// @param other    the object to compare with
//
// @return the result of the comparison (-1,0,1)
//
- (long) compare :(DLong *) other;


//// Parsable protocol

//
// Parse a string for setting the object
//
// @param cstr     the string to be parsed (moved to first non-parsable char)
//
// @return the result (0, ERANGE, ENODATA)
//
- (int) fromString :(char **) cstr;


//// Textable protocol

//
// Return a text string 
//
// @return a (new) text string with the number
//
- (DText *) toText;


//// Datable protocol

//
// Return a data string
//
// @return a (new) data string
//
- (DData *) toData;


//// Endian methods

//
// Return the BigEndian (network order) order for the object
//
// @return the big endian converted long
//
- (long) toBigEndian;

#ifndef WORDS_BIGENDIAN
#endif
//
// Return the LittleEndian order for the object
//
// @return the little endian converted long
//
- (long) toLittleEndian;

#ifdef WORDS_BIGENDIAN
#endif
@end
#endif
