#ifndef _DSHORT_H
#define _DSHORT_H

// This file was automatically generated by objch.

//==============================================================================
//
//         DShort - the short (2 bytes) number class in the ofc-library
//
//               Copyright (C) 2003  Dick van Oudheusden
//  
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free
// Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//==============================================================================
// 
//  $Date: 2005/02/05 06:25:38 $ $Revision: 1.12 $
//
//==============================================================================

#include "ofc/config.h"

#include "ofc/DComparable.h"
#include "ofc/DTextable.h"
#include "ofc/DDatable.h"
#include "ofc/DParsable.h"

#include "ofc/DText.h"
#include "ofc/DData.h"

// The Short class implements a number of methods for storing and manipulating short numbers.

@interface DShort : Object <DComparable,DTextable,DDatable,DParsable>
{
@private
  short        _sh;
}


//// Constructors

//
// Initialise to zero number
//
// @return the object
//
- (DShort *) init;

//
// Initialise to a number
//
// @param number   the number
//
// @return the object
//
- (DShort *) init :(short) number;


//// Main methods

//
// Get the short number
//
// @return the number
//
- (short) get;

//
// Set the short number
//
// @param number  the short
//
// @return the object
//
- (DShort *) set :(short) number;


//// Comparable protocol

//
// Compare two short objects
//
// @param other    the object to compare with
//
// @return the result of the comparison (-1,0,1)
//
- (int) compare :(DShort *) other;


//// Parsable protocol

//
// Parse a string for a short number
//
// @param cstr     the c-string (moved to first non-parseable char)
//
// @return the result (0, ERANGE, ENODATA)
//
- (int) fromString :(char **) cstr;


//// Textable protocol

//
// Return a text string 
//
// @return a (new) text string with the  number
//
- (DText *) toText;


//// Datable protocol

//
// Return a data string
//
// @return a (new) data string
//
- (DData *) toData;


//// Endian methods

//
// Convert the short to a Big Endian (network order) short
//
// @return the converted short
//
- (short) toBigEndian ;

#ifndef WORDS_BIGENDIAN 
#endif
//
// Convert the short to a Little Endian short
//
// @return the converted short
//
- (short) toLittleEndian ;

#ifdef WORDS_BIGENDIAN 
#endif
@end
#endif
