#ifndef _DSYSTEMLOGGER_H
#define _DSYSTEMLOGGER_H

// This file was automatically generated by objch.

//==============================================================================
//
//          DSystemLogger - the system logger in the ofc-library
//
//               Copyright (C) 2004  Dick van Oudheusden
//  
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free
// Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//==============================================================================
// 
//  $Date: 2005/01/30 08:05:48 $ $Revision: 1.3 $
//
//==============================================================================
#ifdef HAVE_DSYSTEMLOGGER
#endif

#include "ofc/config.h"

#include "ofc/DLogger.h"

#ifdef HAVE_SYSLOG_H
#define HAVE_DSYSTEMLOGGER
#endif

#ifdef HAVE_DSYSTEMLOGGER
//
// The DSystemLogger class implements methods for continuous logging
// to the system logger. On Unix this will be the syslog deamon. On
// Win32 there is not an usable logger present. So this class will only
// be present on Unix.
// 

@interface DSystemLogger : Object <DLogger>
{
  int _mask;        // the (copy of) the mask
}
#endif
#ifdef HAVE_DSYSTEMLOGGER

//// Constructors

//
// Initialise a default system logger
//
// @return the object
//
- (DSystemLogger *) init;

//
// Initialise a system logger
// 
// @param appName   the application name (or NULL)
// @param toStdErr  also logging to stderr ?
//
// @return the object
//
- (DSystemLogger *) init :(const char *) appName :(BOOL) toStdErr;


//// Copy constructor

//
// Deepen a copy of the object (not implemented)
//
// @return the object
//
- deepen;


//// Deconstructor

//
// Free the object
//
// @return the object
//
- free;


//// Implementation of interface DLogger

//
// Log an event by the logger
// 
// @param level      the level of the event
// @param message    the message to be logged
// @param parameters the optional parameters for the message
// 
// @return success
// 
- (BOOL) doLog :(int) level :(const char *) message;

//
// Set the active levels
// 
// @param level      the bitwise or'ed active levels 
// 
// @return the previous mask
// 
- (int) mask :(int) levels;

//
// Set the active level range
// 
// @param high        the highest level to mask
// @param low         the lowest level to mask
// 
// @return the previous mask
//
- (int) mask :(int) high :(int) low;

@end
#endif
#endif
